/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   lm_initdata.c                                      :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: tmaze <tmaze@student.42.fr>                +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2019/03/23 17:43:34 by tmaze             #+#    #+#             */
/*   Updated: 2019/04/30 07:06:35 by mndhlovu         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "lem_in.h"

void			lm_initdata(t_lmdata *data)
{
	data->nbants = 0;
	data->nodes_data = NULL;
	data->adj = NULL;
}

int				lm_init_src_dest(int *src, int *dest, t_lmdata *data
				, char *raw)
{
	int			s;
	int			d;
	char		**tab;

	if (raw != NULL)
	{
		tab = ft_strsplit(raw, '-');
		if (tab != NULL)
		{
			s = lm_find_index(data, tab[0]);
			d = lm_find_index(data, tab[1]);
			if (s == -1 || d == -1)
			{
				ft_del_words_tables(&tab);
				return (0);
			}
			*src = s;
			*dest = d;
			ft_del_words_tables(&tab);
			return (1);
		}
	}
	ft_del_words_tables(&tab);
	return (0);
}
